Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3679)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3681)
@@ -25,4 +25,15 @@
 ! -----------------
 ! $Id$
+! Linear interpolations are replaced by first order interpolations. The linear 
+! interpolation routines are still included but not called. In the child 
+! inititialization the interpolation is also changed to 1st order and the linear
+! interpolation is not kept.
+! Subroutine pmci_map_fine_to_coarse_grid is rewritten.
+! Several changes in pmci_init_anterp_tophat.
+! Child's parent-grid arrays (uc, vc,...) are made non-overlapping on the PE-
+! subdomain boundaries in order to allow grid-spacing ratios higher than nbgp. 
+! Subroutine pmci_init_tkefactor is removed as unnecessary.
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! Remove unused variable simulated_time
 ! 
@@ -334,5 +345,5 @@
 
 
-   USE arrays_3d,                                                              &
+    USE arrays_3d,                                                             &
         ONLY:  diss, diss_2, dzu, dzw, e, e_p, e_2, nc, nc_2, nc_p, nr, nr_2,  &
                pt, pt_2, q, q_2, qc, qc_2, qr, qr_2, s, s_2,                   &
@@ -378,5 +389,5 @@
     USE pegrid,                                                                &
         ONLY:  collective_wait, comm1dx, comm1dy, comm2d, myid, myidx, myidy,  &
-               numprocs, pleft, pnorth, pright, psouth, status
+               numprocs, pdims, pleft, pnorth, pright, psouth, status
 
     USE pmc_child,                                                             &
@@ -446,5 +457,4 @@
 !
 !-- Geometry
-    REAL(wp), SAVE                                    ::  area_t             !<
     REAL(wp), SAVE, DIMENSION(:), ALLOCATABLE, PUBLIC ::  coord_x            !<
     REAL(wp), SAVE, DIMENSION(:), ALLOCATABLE, PUBLIC ::  coord_y            !<
@@ -455,15 +465,6 @@
 !-- Children's parent-grid arrays
     INTEGER(iwp), SAVE, DIMENSION(5), PUBLIC    ::  coarse_bound        !< subdomain index bounds for children's parent-grid arrays
-    INTEGER(iwp), SAVE, DIMENSION(4), PUBLIC    ::  coarse_bound_anterp !< subdomain index bounds for anterpolation
-
-    REAL(wp), SAVE                              ::  xexl           !<
-    REAL(wp), SAVE                              ::  xexr           !<
-    REAL(wp), SAVE                              ::  yexs           !<
-    REAL(wp), SAVE                              ::  yexn           !<
-    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_l    !<
-    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_n    !<
-    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_r    !<
-    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_s    !<
-    REAL(wp), SAVE, DIMENSION(:,:), ALLOCATABLE ::  tkefactor_t    !<
+    INTEGER(iwp), SAVE, DIMENSION(4), PUBLIC    ::  coarse_bound_aux    !< subdomain index bounds for allocation of index-mapping and other auxiliary arrays
+    INTEGER(iwp), SAVE, DIMENSION(4), PUBLIC    ::  coarse_bound_w      !< subdomain index bounds for children's parent-grid work arrays
 
     REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  dissc !< coarse grid array on child domain - dissipation rate
@@ -493,4 +494,5 @@
     INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kco    !<
     INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kcw    !<
+    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  celltmpd !<
     REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1xo   !<
     REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2xo   !<
@@ -505,5 +507,5 @@
     REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1zw   !<
     REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2zw   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  celltmpd !<
+
 !
 !-- Child index arrays and log-ratio arrays for the log-law near-wall
@@ -547,7 +549,13 @@
     REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_s   !<
 !
-!-- Upper bounds for k in anterpolation.
-    INTEGER(iwp), SAVE ::  kcto   !<
-    INTEGER(iwp), SAVE ::  kctw   !<
+    INTEGER(iwp), SAVE ::  igsr     !< Integer grid-spacing ratio in i-direction 
+    INTEGER(iwp), SAVE ::  jgsr     !< Integer grid-spacing ratio in j-direction 
+    INTEGER(iwp), SAVE ::  kgsr     !< Integer grid-spacing ratio in k-direction 
+    INTEGER(iwp), SAVE ::  kcto     !< Upper bound for k in anterpolation of variables other than w.
+    INTEGER(iwp), SAVE ::  kctw     !< Upper bound for k in anterpolation of w.
+    INTEGER(iwp), SAVE ::  nxlfc    !< Lower index limit in x-direction for fine-to-coarse index mapping and interpolaton coefficient arrays
+    INTEGER(iwp), SAVE ::  nxrfc    !< Upper index limit in x-direction for fine-to-coarse index mapping and interpolaton coefficient arrays
+    INTEGER(iwp), SAVE ::  nynfc    !< Upper index limit in y-direction for fine-to-coarse index mapping and interpolaton coefficient arrays
+    INTEGER(iwp), SAVE ::  nysfc    !< Lower index limit in y-direction for fine-to-coarse index mapping and interpolaton coefficient arrays
 !
 !-- Upper bound for k in log-law correction in interpolation.
@@ -556,10 +564,4 @@
     INTEGER(iwp), SAVE ::  nzt_topo_nestbc_r   !<
     INTEGER(iwp), SAVE ::  nzt_topo_nestbc_s   !<
-!
-!-- Number of ghost nodes in coarse-grid arrays for i and j in anterpolation.
-    INTEGER(iwp), SAVE ::  nhll   !<
-    INTEGER(iwp), SAVE ::  nhlr   !<
-    INTEGER(iwp), SAVE ::  nhls   !<
-    INTEGER(iwp), SAVE ::  nhln   !<
 !
 !-- Spatial under-relaxation coefficients for anterpolation.
@@ -633,4 +635,17 @@
     INTEGER(idp),ALLOCATABLE,DIMENSION(:,:),PUBLIC,TARGET    :: nr_part  !<
     INTEGER(idp),ALLOCATABLE,DIMENSION(:,:),PUBLIC,TARGET    :: part_adr !<
+
+!AH 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarr_lr
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarr_sn
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarr_t
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarrc_lr
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarrc_sn
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarrc_t
+    INTEGER(iwp) :: workarrc_lr_exchange_type
+    INTEGER(iwp) :: workarrc_sn_exchange_type
+    INTEGER(iwp) :: workarrc_t_exchange_type_x
+    INTEGER(iwp) :: workarrc_t_exchange_type_y
+!AH
     
     INTERFACE pmci_boundary_conds
@@ -914,5 +929,5 @@
           nz_cl = nz
 !
-!--       Find the highest nest level in the coarse grid for the reduced z
+!--       Find the highest nest level in the parent grid for the reduced z
 !--       transfer
           DO  k = 1, nz                 
@@ -1130,5 +1145,6 @@
           CALL MPI_COMM_SIZE( comm1dy, npy, ierr )
 !
-!--       The +1 in index is because PALM starts with nx=0
+!--       Nrx is the same for all PEs and so is nry, thus there is no need to compute
+!--       them separately for each PE.
           nrx = nxr - nxl + 1
           nry = nyn - nys + 1
@@ -1139,8 +1155,8 @@
 !
 !--          Area along y required by actual child PE
-             DO  j = coarse_bound_all(3,k), coarse_bound_all(4,k)
+             DO  j = coarse_bound_all(3,k), coarse_bound_all(4,k)  !: j = jcs, jcn of PE# k 
 !
 !--             Area along x required by actual child PE
-                DO  i = coarse_bound_all(1,k), coarse_bound_all(2,k)
+                DO  i = coarse_bound_all(1,k), coarse_bound_all(2,k)  !: i = icl, icr of PE# k 
 
                    px = i / nrx
@@ -1230,14 +1246,18 @@
     INTEGER(iwp) ::  i          !<
     INTEGER(iwp) ::  ierr       !< 
-    INTEGER(iwp) ::  icl        !< left index limit for children's parent-grid arrays
-    INTEGER(iwp) ::  icla       !< left index limit for anterpolation
-    INTEGER(iwp) ::  icr        !< left index limit for children's parent-grid arrays
-    INTEGER(iwp) ::  icra       !< right index limit for anterpolation
+    INTEGER(iwp) ::  icl        !< Left index limit for children's parent-grid arrays
+    INTEGER(iwp) ::  icla       !< Left index limit for allocation of index-mapping and other auxiliary arrays
+    INTEGER(iwp) ::  iclw       !< Left index limit for children's parent-grid work arrays
+    INTEGER(iwp) ::  icr        !< Left index limit for children's parent-grid arrays
+    INTEGER(iwp) ::  icra       !< Right index limit for allocation of index-mapping and other auxiliary arrays
+    INTEGER(iwp) ::  icrw       !< Right index limit for children's parent-grid work arrays
     INTEGER(iwp) ::  j          !< 
-    INTEGER(iwp) ::  jcn        !< north index limit for children's parent-grid arrays
-    INTEGER(iwp) ::  jcna       !< north index limit for anterpolation
-    INTEGER(iwp) ::  jcs        !< sout index limit for children's parent-grid arrays
-    INTEGER(iwp) ::  jcsa       !< south index limit for anterpolation
-    INTEGER(iwp) ::  n          !< running index for number of chemical species
+    INTEGER(iwp) ::  jcn        !< North index limit for children's parent-grid arrays
+    INTEGER(iwp) ::  jcna       !< North index limit for allocation of index-mapping and other auxiliary arrays
+    INTEGER(iwp) ::  jcnw       !< North index limit for children's parent-grid work arrays
+    INTEGER(iwp) ::  jcs        !< South index limit for children's parent-grid arrays
+    INTEGER(iwp) ::  jcsa       !< South index limit for allocation of index-mapping and other auxiliary arrays
+    INTEGER(iwp) ::  jcsw       !< South index limit for children's parent-grid work arrays
+    INTEGER(iwp) ::  n          !< Running index for number of chemical species
 
     INTEGER(iwp), DIMENSION(5) ::  val        !<
@@ -1441,12 +1461,4 @@
        ENDIF
 !
-!--    Define the SGS-TKE scaling factor based on the grid-spacing ratio. Only
-!--    if both parent and child are in LES mode or in RANS mode. 
-!--    Please note, in case parent and child are in RANS mode, TKE weighting 
-!--    factor is simply one. 
-       IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.         &
-            (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.          &
-               .NOT. constant_diffusion ) )  CALL pmci_init_tkefactor
-!
 !--    Two-way coupling for general and vertical nesting.
 !--    Precompute the index arrays and relaxation functions for the
@@ -1457,8 +1469,4 @@
 !--    included in the interpolation algorithms.
        CALL pmci_init_anterp_tophat
-!
-!--    Finally, compute the total area of the top-boundary face of the domain.
-!--    This is needed in the pmc_ensure_nest_mass_conservation      
-       area_t = ( nx + 1 ) * (ny + 1 ) * dx * dy
 
     ENDIF
@@ -1476,78 +1484,76 @@
        INTEGER(iwp), DIMENSION(2)          ::  size_of_array      !<
                                    
-       INTEGER(iwp) :: i        !<   
+       INTEGER(iwp) :: i        !< 
+       INTEGER(iwp) :: iauxl    !<
+       INTEGER(iwp) :: iauxr    !<
        INTEGER(iwp) :: ijaux    !< 
-       INTEGER(iwp) :: j        !< 
+       INTEGER(iwp) :: j        !<
+       INTEGER(iwp) :: jauxs    !<
+       INTEGER(iwp) :: jauxn    !< 
        REAL(wp) ::  loffset     !<
        REAL(wp) ::  noffset     !<
        REAL(wp) ::  roffset     !<
        REAL(wp) ::  soffset     !<
-
-!
-!--    If the fine- and coarse grid nodes do not match:
-       loffset = MOD( coord_x(nxl), cg%dx )
-       xexl    = cg%dx + loffset
-!
-!--    This is needed in the anterpolation phase
-       nhll = CEILING( xexl / cg%dx )
-       xcs  = coord_x(nxl) - xexl
-       DO  i = 0, cg%nx
-          IF ( cg%coord_x(i) > xcs )  THEN
-             icl = MAX( -1, i-1 )
-             EXIT
-          ENDIF
-       ENDDO
-!
-!--    If the fine- and coarse grid nodes do not match
-       roffset = MOD( coord_x(nxr+1), cg%dx )
-       xexr    = cg%dx + roffset
-!
-!--    This is needed in the anterpolation phase
-       nhlr = CEILING( xexr / cg%dx )
-       xce  = coord_x(nxr+1) + xexr
-!--    One "extra" layer is taken behind the right boundary 
-!--    because it may be needed in cases of non-integer grid-spacing ratio
-       DO  i = cg%nx, 0 , -1
-          IF ( cg%coord_x(i) < xce )  THEN
-             icr = MIN( cg%nx+1, i+1 )
-             EXIT
-          ENDIF
-       ENDDO
-!
-!--    If the fine- and coarse grid nodes do not match
-       soffset = MOD( coord_y(nys), cg%dy )
-       yexs    = cg%dy + soffset
-!
-!--    This is needed in the anterpolation phase
-       nhls = CEILING( yexs / cg%dy )
-       ycs  = coord_y(nys) - yexs
-       DO  j = 0, cg%ny
-          IF ( cg%coord_y(j) > ycs )  THEN
-             jcs = MAX( -nbgp, j-1 )
-             EXIT
-          ENDIF
-       ENDDO
-!
-!--    If the fine- and coarse grid nodes do not match
-       noffset = MOD( coord_y(nyn+1), cg%dy )
-       yexn    = cg%dy + noffset
-!
-!--    This is needed in the anterpolation phase
-       nhln = CEILING( yexn / cg%dy )
-       yce  = coord_y(nyn+1) + yexn
-!--    One "extra" layer is taken behind the north boundary 
-!--    because it may be needed in cases of non-integer grid-spacing ratio
-       DO  j = cg%ny, 0, -1
-          IF ( cg%coord_y(j) < yce )  THEN
-             jcn = MIN( cg%ny + nbgp, j+1 )
-             EXIT
-          ENDIF
-       ENDDO
-
-       coarse_bound(1) = icl
-       coarse_bound(2) = icr
-       coarse_bound(3) = jcs
-       coarse_bound(4) = jcn
-       coarse_bound(5) = myid
+       REAL(wp) ::  xexl        !< Parent-grid array exceedance behind the left edge of the child PE subdomain
+       REAL(wp) ::  xexr        !< Parent-grid array exceedance behind the right edge of the child PE subdomain 
+       REAL(wp) ::  yexs        !< Parent-grid array exceedance behind the south edge of the child PE subdomain
+       REAL(wp) ::  yexn        !< Parent-grid array exceedance behind the north edge of the child PE subdomain
+
+!AH!
+!AH!--    If the fine- and coarse grid nodes do not match:
+!AH       loffset = MOD( coord_x(nxl), cg%dx )
+!AH       xexl    = cg%dx + loffset
+!AH       xcs  = coord_x(nxl) - xexl
+!AH       DO  i = 0, cg%nx
+!AH          IF ( cg%coord_x(i) > xcs )  THEN
+!AH             icl = MAX( -1, i-1 )
+!AH             EXIT
+!AH          ENDIF
+!AH       ENDDO
+!AH!
+!AH!--    If the fine- and coarse grid nodes do not match
+!AH       roffset = MOD( coord_x(nxr+1), cg%dx )
+!AH       xexr    = cg%dx + roffset
+!AH       xce  = coord_x(nxr+1)
+!AH       IF ( nxr == nx )  THEN
+!AH          xce = xce + xexr
+!AH       ENDIF
+!AH       DO  i = cg%nx, 0 , -1
+!AH          IF ( cg%coord_x(i) < xce )  THEN
+!AH             icr = MIN( cg%nx+1, i+1 )
+!AH             EXIT
+!AH          ENDIF
+!AH       ENDDO
+!AH!
+!AH!--    If the fine- and coarse grid nodes do not match
+!AH       soffset = MOD( coord_y(nys), cg%dy )
+!AH       yexs    = cg%dy + soffset
+!AH       ycs  = coord_y(nys) - yexs
+!AH       DO  j = 0, cg%ny
+!AH          IF ( cg%coord_y(j) > ycs )  THEN
+!AH             jcs = MAX( -nbgp, j-1 )
+!AH             EXIT
+!AH          ENDIF
+!AH       ENDDO
+!AH!
+!AH!--    If the fine- and coarse grid nodes do not match
+!AH       noffset = MOD( coord_y(nyn+1), cg%dy )
+!AH       yexn    = cg%dy + noffset
+!AH       yce  = coord_y(nyn+1)
+!AH       IF ( nyn == ny )  THEN
+!AH          yce = yce + yexn
+!AH       ENDIF
+!AH       DO  j = cg%ny, 0, -1
+!AH          IF ( cg%coord_y(j) < yce )  THEN
+!AH             jcn = MIN( cg%ny + nbgp, j+1 )
+!AH             EXIT
+!AH          ENDIF
+!AH       ENDDO
+!AH
+!AH       coarse_bound(1) = icl
+!AH       coarse_bound(2) = icr
+!AH       coarse_bound(3) = jcs
+!AH       coarse_bound(4) = jcn
+!AH       coarse_bound(5) = myid
 !
 !--    Determine the anterpolation index limits. If at least half of the 
@@ -1557,57 +1563,112 @@
 !--    anterpolation domain, or not included at all if we are at the outer 
 !--    edge of the child domain.
+
+!
+!--    Left
+       IF  ( bc_dirichlet_l )  THEN
+          loffset = MOD( coord_x(nxl), cg%dx )
+          xexl  = 2 * cg%dx + loffset
+          iauxl = 0
+       ELSE
+          xexl  = 0.0_wp
+          iauxl = 1
+       ENDIF
+       xcs     = coord_x(nxl) - xexl
        DO  i = 0, cg%nx
-          IF ( cg%coord_x(i) + 0.5_wp * cg%dx >= coord_x(nxl) )  THEN
-             icla = MAX( 0, i )
+          IF ( cg%coord_x(i) + 0.5_wp * cg%dx >= xcs )  THEN
+             icl = MAX( 0, i )
              EXIT
           ENDIF
        ENDDO
+!
+!--    Right
+       IF  ( bc_dirichlet_r )  THEN
+          roffset = MOD( coord_x(nxr+1), cg%dx )
+          xexr  = 2 * cg%dx + roffset
+          iauxr = 0  
+       ELSE
+          xexr  = 0.0_wp
+          iauxr = 1  
+       ENDIF
+       xce  = coord_x(nxr+1) + xexr
        DO  i = cg%nx, 0 , -1
-          IF ( cg%coord_x(i) + 0.5_wp * cg%dx <= coord_x(nxr+1) )  THEN
-             icra = MIN( cg%nx, i )
+          IF ( cg%coord_x(i) + 0.5_wp * cg%dx <= xce )  THEN
+             icr = MIN( cg%nx, i )
              EXIT
           ENDIF
        ENDDO
+!
+!--    South
+       IF  ( bc_dirichlet_s )  THEN
+          soffset = MOD( coord_y(nys), cg%dy )
+          yexs  = 2 * cg%dy + soffset
+          jauxs = 0  
+       ELSE
+          yexs  = 0.0_wp
+          jauxs = 1  
+       ENDIF
+       ycs  = coord_y(nys) - yexs
        DO  j = 0, cg%ny
-          IF ( cg%coord_y(j) + 0.5_wp * cg%dy >= coord_y(nys) )  THEN
-             jcsa = MAX( 0, j )
+          IF ( cg%coord_y(j) + 0.5_wp * cg%dy >= ycs )  THEN
+             jcs = MAX( 0, j )
              EXIT
           ENDIF
        ENDDO
+!
+!--    North
+       IF  ( bc_dirichlet_n )  THEN
+          noffset = MOD( coord_y(nyn+1), cg%dy )
+          yexn  = 2 * cg%dy + noffset
+          jauxn = 0
+       ELSE
+          yexn  = 0.0_wp
+          jauxn = 1
+       ENDIF
+       yce  = coord_y(nyn+1) + yexn
        DO  j = cg%ny, 0 , -1
-          IF ( cg%coord_y(j) + 0.5_wp * cg%dy <= coord_y(nyn+1) )  THEN
-             jcna = MIN( cg%ny, j )
+          IF ( cg%coord_y(j) + 0.5_wp * cg%dy <= yce )  THEN
+             jcn = MIN( cg%ny, j )
              EXIT
           ENDIF
        ENDDO
 !
-!--    Make sure that the indexing is contiguous 
+!--    Make sure that the indexing is contiguous (no gaps, no overlaps) 
+#if defined( __parallel )
        IF ( nxl == 0 )  THEN
-          CALL MPI_SEND( icra, 1, MPI_INTEGER, pright, 717, comm2d, ierr )
+          CALL MPI_SEND( icr, 1, MPI_INTEGER, pright, 717, comm2d, ierr )
        ELSE IF ( nxr == nx )  THEN
           CALL MPI_RECV( ijaux, 1, MPI_INTEGER, pleft, 717, comm2d, status, ierr )
-          icla = ijaux + 1
+          icl = ijaux + 1
        ELSE
-          CALL MPI_SEND( icra, 1, MPI_INTEGER, pright, 717, comm2d, ierr )
+          CALL MPI_SEND( icr, 1, MPI_INTEGER, pright, 717, comm2d, ierr )
           CALL MPI_RECV( ijaux, 1, MPI_INTEGER, pleft, 717, comm2d, status, ierr ) 
-          icla = ijaux + 1
+          icl = ijaux + 1
        ENDIF
        IF ( nys == 0 )  THEN
-          CALL MPI_SEND( jcna, 1, MPI_INTEGER, pnorth, 719, comm2d, ierr )
+          CALL MPI_SEND( jcn, 1, MPI_INTEGER, pnorth, 719, comm2d, ierr )
        ELSE IF ( nyn == ny )  THEN
           CALL MPI_RECV( ijaux, 1, MPI_INTEGER, psouth, 719, comm2d, status, ierr )
-          jcsa = ijaux + 1
+          jcs = ijaux + 1
        ELSE
-          CALL MPI_SEND( jcna, 1, MPI_INTEGER, pnorth, 719, comm2d, ierr )
+          CALL MPI_SEND( jcn, 1, MPI_INTEGER, pnorth, 719, comm2d, ierr )
           CALL MPI_RECV( ijaux, 1, MPI_INTEGER, psouth, 719, comm2d, status, ierr ) 
-          jcsa = ijaux + 1
+          jcs = ijaux + 1
        ENDIF
-
-       write(9,"('Anterpolation bounds: ',4(i3,2x))") icla, icra, jcsa, jcna
-       flush(9)
-       coarse_bound_anterp(1) = icla
-       coarse_bound_anterp(2) = icra
-       coarse_bound_anterp(3) = jcsa
-       coarse_bound_anterp(4) = jcna
+#endif       
+
+       WRITE(9,"('Pmci_map_fine_to_coarse_grid. parent-grid array bounds: ',4(i3,2x))") icl, icr, jcs, jcn
+       FLUSH(9)
+
+       coarse_bound(1) = icl
+       coarse_bound(2) = icr
+       coarse_bound(3) = jcs
+       coarse_bound(4) = jcn
+       coarse_bound(5) = myid
+!
+!--    The following index bounds are used for allocating index mapping and some other auxiliary arrays
+       coarse_bound_aux(1) = icl - iauxl
+       coarse_bound_aux(2) = icr + iauxr
+       coarse_bound_aux(3) = jcs - jauxs
+       coarse_bound_aux(4) = jcn + jauxn
 !
 !--    Note that MPI_Gather receives data from all processes in the rank order
@@ -1636,62 +1697,68 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  acsize  !<
-       INTEGER(iwp) ::  i       !<
-       INTEGER(iwp) ::  j       !<
-       INTEGER(iwp) ::  k       !<
-       INTEGER(iwp) ::  kc      !<
-       INTEGER(iwp) ::  kdzo    !<
-       INTEGER(iwp) ::  kdzw    !<       
-
-       REAL(wp) ::  dzmin       !<
-       REAL(wp) ::  parentdzmax !<
-       REAL(wp) ::  xb          !<
-       REAL(wp) ::  xcsu        !<
-       REAL(wp) ::  xfso        !<
-       REAL(wp) ::  xcso        !<
-       REAL(wp) ::  xfsu        !<
-       REAL(wp) ::  yb          !<
-       REAL(wp) ::  ycso        !<
-       REAL(wp) ::  ycsv        !<
-       REAL(wp) ::  yfso        !<
-       REAL(wp) ::  yfsv        !<
-       REAL(wp) ::  zcso        !<
-       REAL(wp) ::  zcsw        !<
-       REAL(wp) ::  zfso        !<
-       REAL(wp) ::  zfsw        !<
+       INTEGER(iwp) ::  acsize   !< Maximum dimension of anterpolation cell.
+       INTEGER(iwp) ::  i        !< Child-grid i-index
+       INTEGER(iwp) ::  ierr     !< MPI error code
+       INTEGER(iwp) ::  j        !< Child-grid j-index
+       INTEGER(iwp) ::  k        !< Child-grid k-index
+       INTEGER(iwp) ::  kc       !< 
+       INTEGER(iwp) ::  kdzo     !<
+       INTEGER(iwp) ::  kdzw     !<
+       INTEGER(iwp) ::  moff     !< Parent-grid bound offset in j-direction
+       INTEGER(iwp) ::  loff     !< Parent-grid bound offset in i-direction
+
+       REAL(wp) ::  dzmin        !<
+       REAL(wp) ::  parentdzmax  !<
+       REAL(wp) ::  xb           !<
+       REAL(wp) ::  xcsu         !<
+       REAL(wp) ::  xfso         !<
+       REAL(wp) ::  xcso         !<
+       REAL(wp) ::  xfsu         !<
+       REAL(wp) ::  yb           !<
+       REAL(wp) ::  ycso         !<
+       REAL(wp) ::  ycsv         !<
+       REAL(wp) ::  yfso         !<
+       REAL(wp) ::  yfsv         !<
+       REAL(wp) ::  zcso         !<
+       REAL(wp) ::  zcsw         !<
+       REAL(wp) ::  zfso         !<
+       REAL(wp) ::  zfsw         !<
       
        
-       xb = nxl * dx
-       yb = nys * dy
-      
-       ALLOCATE( icu(nxlg:nxrg) )
-       ALLOCATE( ico(nxlg:nxrg) )
-       ALLOCATE( jcv(nysg:nyng) )
-       ALLOCATE( jco(nysg:nyng) )
-       ALLOCATE( kcw(nzb:nzt+1) )
-       ALLOCATE( kco(nzb:nzt+1) )
-       ALLOCATE( r1xu(nxlg:nxrg) )
-       ALLOCATE( r2xu(nxlg:nxrg) )
-       ALLOCATE( r1xo(nxlg:nxrg) )
-       ALLOCATE( r2xo(nxlg:nxrg) )
-       ALLOCATE( r1yv(nysg:nyng) )
-       ALLOCATE( r2yv(nysg:nyng) )
-       ALLOCATE( r1yo(nysg:nyng) )
-       ALLOCATE( r2yo(nysg:nyng) )
-       ALLOCATE( r1zw(nzb:nzt+1) )
-       ALLOCATE( r2zw(nzb:nzt+1) )
-       ALLOCATE( r1zo(nzb:nzt+1) )
-       ALLOCATE( r2zo(nzb:nzt+1) )
-!
-!--    Note that the node coordinates xfs... and xcs... are relative to the
-!--    lower-left-bottom corner of the fc-array, not the actual child domain
-!--    corner
-       DO  i = nxlg, nxrg
-          xfsu    = coord_x(i) - ( lower_left_coord_x + xb - xexl )
-          xfso    = coord_x(i) + 0.5_wp * dx - ( lower_left_coord_x + xb - xexl )
-          icu(i)  = icl + FLOOR( xfsu / cg%dx )
-          ico(i)  = icl + FLOOR( ( xfso - 0.5_wp * cg%dx ) / cg%dx )
-          xcsu    = ( icu(i) - icl ) * cg%dx
-          xcso    = ( ico(i) - icl ) * cg%dx + 0.5_wp * cg%dx
+!AH
+!
+!--    Allocate child-grid work arrays for interpolation.
+       CALL pmci_allocate_finegrid_workarrays
+!       
+!--    Determine index bounds for the parent-grid work arrays for
+!--    interpolation and allocate them.
+       CALL pmci_allocate_coarsegrid_workarrays
+!       
+!--    Define the MPI-datatypes for parent-grid work array 
+!--    exchange between the PE-subdomains.
+       CALL pmci_create_coarsegrid_workarray_exchange_datatypes
+!
+!--    Determine index bounds for the fine-to-coarse grid index mapping arrays 
+!--    and interpolation-coefficient arrays and allocate them.       
+       CALL pmci_allocate_fine_to_coarse_mapping_arrays
+!AH       
+!
+       xb   = nxl * dx
+       IF  ( bc_dirichlet_l )  THEN
+          loff = 2
+       ELSE
+          loff = 0
+       ENDIF
+!AH       DO  i = nxlg, nxrg
+       DO  i = nxl-1, nxr+1
+          xfsu    = coord_x(i) - ( lower_left_coord_x + xb )
+          xfso    = coord_x(i) + 0.5_wp * dx - ( lower_left_coord_x + xb )
+!
+!--       icl points to 2 parent-grid cells left form the left nest boundary,
+!--       thence icl + loff points to the left nest boundary.
+          icu(i)  = icl + loff + FLOOR( xfsu / cg%dx )
+          ico(i)  = icl + loff + FLOOR( ( xfso - 0.5_wp * cg%dx ) / cg%dx )
+          xcsu    = ( icu(i) - ( icl + loff ) ) * cg%dx
+          xcso    = ( ico(i) - ( icl + loff ) + 0.5_wp ) * cg%dx
           r2xu(i) = ( xfsu - xcsu ) / cg%dx
           r2xo(i) = ( xfso - xcso ) / cg%dx
@@ -1699,12 +1766,56 @@
           r1xo(i) = 1.0_wp - r2xo(i)
        ENDDO
-
-       DO  j = nysg, nyng
-          yfsv    = coord_y(j) - ( lower_left_coord_y + yb - yexs )
-          yfso    = coord_y(j) + 0.5_wp * dy - ( lower_left_coord_y + yb - yexs )
-          jcv(j)  = jcs + FLOOR( yfsv / cg%dy )
-          jco(j)  = jcs + FLOOR( ( yfso -0.5_wp * cg%dy ) / cg%dy )
-          ycsv    = ( jcv(j) - jcs ) * cg%dy
-          ycso    = ( jco(j) - jcs ) * cg%dy + 0.5_wp * cg%dy
+!       
+!--    Fill up the values behind nest boundaries by copying from inside 
+!--    the domain.
+       IF  ( bc_dirichlet_l )  THEN
+          icu(nxlfc:nxl-1)  = icu(nxlfc+igsr:nxl-1+igsr) - 1
+          r1xu(nxlfc:nxl-1) = r1xu(nxlfc+igsr:nxl-1+igsr)
+          r2xu(nxlfc:nxl-1) = r2xu(nxlfc+igsr:nxl-1+igsr)
+          ico(nxlfc:nxl-1)  = ico(nxlfc+igsr:nxl-1+igsr) - 1
+          r1xo(nxlfc:nxl-1) = r1xo(nxlfc+igsr:nxl-1+igsr)
+          r2xo(nxlfc:nxl-1) = r2xo(nxlfc+igsr:nxl-1+igsr)
+       ENDIF
+       
+       IF  ( bc_dirichlet_r )  THEN
+          icu(nxr+1:nxrfc)  = icu(nxr+1-igsr:nxrfc-igsr) + 1
+          r1xu(nxr+1:nxrfc) = r1xu(nxr+1-igsr:nxrfc-igsr)
+          r2xu(nxr+1:nxrfc) = r2xu(nxr+1-igsr:nxrfc-igsr)
+          ico(nxr+1:nxrfc)  = ico(nxr+1-igsr:nxrfc-igsr) + 1
+          r1xo(nxr+1:nxrfc) = r1xo(nxr+1-igsr:nxrfc-igsr)
+          r2xo(nxr+1:nxrfc) = r2xo(nxr+1-igsr:nxrfc-igsr)
+       ENDIF
+!
+!--    Print out the indices and coefficients for checking and debugging purposes
+       DO  i = nxlfc, nxrfc
+          WRITE(9,"('pmci_init_interp_tril: i, icu, r1xu r2xu ', 2(i4,2x),2(e12.5,2x))") &
+               i, icu(i), r1xu(i), r2xu(i)
+          FLUSH(9)
+       ENDDO
+       WRITE(9,*)
+       DO  i = nxlfc, nxrfc
+          WRITE(9,"('pmci_init_interp_tril: i, ico, r1xo r2xo ', 2(i4,2x),2(e12.5,2x))") &
+               i, ico(i), r1xo(i), r2xo(i)
+          FLUSH(9)
+       ENDDO
+       WRITE(9,*)
+
+       yb   = nys * dy
+       IF  ( bc_dirichlet_s )  THEN
+          moff = 2
+       ELSE
+          moff = 0
+       ENDIF
+!AH       DO  j = nysg, nyng
+       DO  j = nys-1, nyn+1
+          yfsv    = coord_y(j) - ( lower_left_coord_y + yb )
+          yfso    = coord_y(j) + 0.5_wp * dy - ( lower_left_coord_y + yb )
+!
+!--       jcs points to 2 parent-grid cells south form the south nest boundary,
+!--       thence jcs + moff points to the south nest boundary.
+          jcv(j)  = jcs + moff + FLOOR( yfsv / cg%dy )
+          jco(j)  = jcs + moff + FLOOR( ( yfso - 0.5_wp * cg%dy ) / cg%dy )
+          ycsv    = ( jcv(j) - ( jcs + moff ) ) * cg%dy
+          ycso    = ( jco(j) - ( jcs + moff ) + 0.5_wp ) * cg%dy
           r2yv(j) = ( yfsv - ycsv ) / cg%dy
           r2yo(j) = ( yfso - ycso ) / cg%dy
@@ -1712,4 +1823,38 @@
           r1yo(j) = 1.0_wp - r2yo(j)
        ENDDO
+!       
+!--    Fill up the values behind nest boundaries by copying from inside 
+!--    the domain.
+       IF  ( bc_dirichlet_s )  THEN
+          jcv(nysfc:nys-1)  = jcv(nysfc+jgsr:nys-1+jgsr) - 1
+          r1yv(nysfc:nys-1) = r1yv(nysfc+jgsr:nys-1+jgsr)
+          r2yv(nysfc:nys-1) = r2yv(nysfc+jgsr:nys-1+jgsr)
+          jco(nysfc:nys-1)  = jco(nysfc+jgsr:nys-1+jgsr) - 1
+          r1yo(nysfc:nys-1) = r1yo(nysfc+jgsr:nys-1+jgsr)
+          r2yo(nysfc:nys-1) = r2yo(nysfc+jgsr:nys-1+jgsr)
+       ENDIF
+       
+       IF  ( bc_dirichlet_n )  THEN
+          jcv(nyn+1:nynfc)  = jcv(nyn+1-jgsr:nynfc-jgsr) + 1
+          r1yv(nyn+1:nynfc) = r1yv(nyn+1-jgsr:nynfc-jgsr)
+          r2yv(nyn+1:nynfc) = r2yv(nyn+1-jgsr:nynfc-jgsr)
+          jco(nyn+1:nynfc)  = jco(nyn+1-jgsr:nynfc-jgsr) + 1
+          r1yo(nyn+1:nynfc) = r1yo(nyn+1-jgsr:nynfc-jgsr)
+          r2yo(nyn+1:nynfc) = r2yo(nyn+1-jgsr:nynfc-jgsr)
+       ENDIF
+!
+!--    Print out the indices and coefficients for checking and debugging purposes
+       DO  j = nysfc, nynfc
+          WRITE(9,"('pmci_init_interp_tril: j, jcv, r1yv r2yv ', 2(i4,2x),2(e12.5,2x))") &
+               j, jcv(j), r1yv(j), r2yv(j)
+          FLUSH(9)
+       ENDDO
+       WRITE(9,*)
+       DO  j = nysfc, nynfc
+          WRITE(9,"('pmci_init_interp_tril: j, jco, r1yo r2yo ', 2(i4,2x),2(e12.5,2x))") &
+               j, jco(j), r1yo(j), r2yo(j)
+          FLUSH(9)
+       ENDDO
+       WRITE(9,*)
 
        DO  k = nzb, nzt + 1
@@ -1736,4 +1881,30 @@
           r1zo(k) = 1.0_wp - r2zo(k)
        ENDDO
+!
+!--    Set the interpolation index- and coefficient-information to the 
+!--    child-grid cells within the uppermost parent-grid cell. This 
+!--    information is only needed for the reversibility correction.   
+       kco(nzt+2:nzt+kgsr)  = kco(nzt+1) + 1 
+       r1zo(nzt+2:nzt+kgsr) = r1zo(nzt+2-kgsr:nzt)
+       r2zo(nzt+2:nzt+kgsr) = r2zo(nzt+2-kgsr:nzt)
+! 
+!--    kcw, r1zw and r2zw are not needed when k > nzt+1
+       kcw(nzt+2:nzt+kgsr)  = 0
+       r1zw(nzt+2:nzt+kgsr) = 0.0_wp
+       r2zw(nzt+2:nzt+kgsr) = 0.0_wp
+!
+!--    Print out the indices and coefficients for checking and debugging purposes
+       DO  k = nzb, nzt+1
+          WRITE(9,"('pmci_init_interp_tril: k, kcw, r1zw r2zw ', 2(i4,2x),2(e12.5,2x))") &
+               k, kcw(k), r1zw(k), r2zw(k)
+          FLUSH(9)
+       ENDDO
+       WRITE(9,*)
+       DO  k = nzb, nzt + kgsr
+          WRITE(9,"('pmci_init_interp_tril: k, kco, r1zo r2zo ', 2(i4,2x),2(e12.5,2x))") &
+               k, kco(k), r1zo(k), r2zo(k)
+          FLUSH(9)
+       ENDDO
+       WRITE(9,*)
 !
 !--    Determine the maximum dimension of anterpolation cells and allocate the
